;
;         <   -     
;                            EEPROM  >

            list        p=pic16f84a ;    
            errorlevel 0,-305      ;
            include   <p16f84a.inc>;  
            __CONFIG _XT_OSC & _WDT_OFF & _PWRTE_ON & _CP_OFF ; 
                                   ;   
EECon1      equ        88h
EECon2      equ        89h
EEDATA      equ        08h
EEADR       equ        09h

            cblock     h'0c'       ;      0,
                                   ;    h'0c          
                                   ;    
                                   ;    :                     
            fig_0.1                ; -  ;
            fig_1                  ; -  ;
            fig_10                 ; -  .
            AdrFig                 ;        
                                   ;  fig,     
                                   ; 
            Anod                   ;    , 
                                   ;  ,      
                                   ; 
            W_copy                 ;  
            STATUS_copy            ;
            FSR_copy               ;                   
            COM_REG                ; ,   .   
            count                  ; DS18B20   
            TEMP_LO                ;    .    -
            TEMP_HI                ;   
            dopcontr               ;     -
                                   ;   
            Schet                  ; ,     8 
                                   ;   
            Contr_L0.1             ;  ,     
            Contr_L1               ;            
            Contr_L10              ;
                                   ;  ,     
            Contr_H0.1             ;    
            Contr_H1               ; 
            Contr_H10              ;
                                   ;     
            Interval               ; .                                      
            contr                  ;     
            Mercan                 ; ,   
            _adres_                ;   
            zapcontr               ; .  ,   
                                   ;    1               
            endc                   ; 
;***************************    **********************************
            org        0           ;  
                                   ;
            goto       Start       ;
            org        4           ;      
                                   ;  

Indicacia  ; ,   
           ;      
                                   ;
          movwf      W_copy        ;   
          movf       STATUS,w      ; 
          movwf      STATUS_copy   ;
          movf       FSR,w         ;
          movwf      FSR_copy      ;
                                   ; 
          bcf        PORTA,0       ;     
          bcf        PORTA,1       ;
          bcf        PORTA,2       ;                           
          movf       AdrFig,w      ;
          movwf      FSR           ;    . FSR
          movf       INDF,w        ;    fig_0.1   w
          iorlw      B'11110000'   ;       
          movwf      PORTB         ;    
                                   ;    contr   0,
          movf       contr,w       ;     -
          bz         osn           ;   
          incfsz     H'28'         ;    
          goto       mks           ;
          incf       H'29'         ;      H'51'
          movf       H'29',w       ;     
          bcf        STATUS,C      ;
          subwf      Interval,w    ;   (Interval)<( H'51'),  =0 
          btfsc      STATUS,C      ;     - 
          goto       mks           ;    
          clrf        H'29'        ; 
          movlw      .1            ;
          xorwf       _adres_      ;      .1 
mks       movf       _adres_,w   ;     _adres_  0,  
          bnz        osn           ;    rpt
          movf       Mercan,w      ;
            bcf        STATUS,2
          xorwf      Anod,w        ;
             btfsc     STATUS,2
             goto      vpk
osn       movf       Anod,w        ;
vpt          btfsc      PORTA,3  ;     PORTA,3  1,  
          addlw      B'00001000'   ;     
                                   ;      . TERMO
vpk       addlw      B'00010000'   ;   1  
          movwf      PORTA         ;                    
          incf       AdrFig
rpt       movf       Anod,w        ;
          bcf        STATUS,2      ;    Z  STATUS
          xorlw      B'00000010'   ; ? ,      
          btfss      STATUS,2      ; ?
          goto       Mack          ; 
          bcf        PORTB,4       ;  ,  
Mack      bcf        STATUS,C      ;
          rrf        Anod,f        ;      
          btfss      STATUS,C      ; 
          goto       ENDINT
           movf       contr,w     ; ,    - 
            bz         frt         ;         AdrFig
          sublw      B'00000001'   ;
          bz         hat           ;
          movlw      Contr_L0.1    ;
          goto       univ          ;
hat       movlw      Contr_H0.1    ;
          goto       univ          ;
frt       movlw      fig_0.1       ;
univ      movwf      AdrFig        ;
          movlw      B'00000100'   ;
          movwf      Anod          ;
ENDINT               ;   
          movf       FSR_copy,w    ;
          movwf      FSR           ;
          movf       STATUS_copy,w ;
          movwf      STATUS        ;
          swapf      W_copy,f      ;
          swapf      W_copy,w      ;
          bcf        INTCON,2      ;   
          retfie                   ;
;---------------------------------------------------------------           
Start                              ;
            call       Portinic    ;    
            call       Timerinic   ;
            call       PredelTemp  ; 
            call       Okruglenia  ;
                                   ;          
            goto       TERMO       ;  
   
;**********************       *******
Portinic                           ;
            movlw      B'00010000' ;   RA4   
            movwf      PORTA       ; 
            bsf        STATUS,5    ;   1
            movlw      B'00000000' ;      
            movwf      TRISA       ; 
            movlw      B'11100000' ;   
             movwf     TRISB       ;
            bcf        STATUS,5    ;     
            movlw      B'11110000' ;   
            movwf      PORTB       ;
            clrf       fig_0.1     ;    fig...          
            clrf       fig_1       ;
            clrf       fig_10      ;                        
            clrf        contr      ;
            movlw      B'00000100' ;  .      
            movwf      Anod        ;   
            movlw      fig_0.1     ;    1-  
            movwf      AdrFig      ;    fig_0.1   AdrFig
            return                 ;
            
;*********************   . OPTION   TMRO ****
Timerinic 
            clrf       count       ;   
            bsf        STATUS,5    ;    , 
            movlw      b'00000010' ;  16, .   , -
            movwf      OPTION_REG  ;     
            bcf        STATUS,5    ;  4.1
            movlw      b'00000000' ;   
            movwf      INTCON      ;
            return
;*********************    EEPROM   
;************     ************************
PredelTemp
            bcf        STATUS,5    ;    EEPROM   -
                                   ;       
            movlw      0           ;      0  
                                   ;      EEPROM
            movwf      EEADR       ;      EEADR
            bsf        STATUS,5    ;    1,   .EECON1
            bsf        EECon1,0    ;  
            bcf        STATUS,5    ;  0-    EEDATA -   -
            movf       EEDATA,w    ;   .    EEPROM
            movwf      Contr_L0.1  ;      0 
                                   ;    Contr_L0.1
            bcf        STATUS,2    ;   z    -  
                                   ;     0 EEPROM  ?
            xorlw      B'11111111' ;  FFh,  z=1    
            btfsc      STATUS,2    ;  EEPROM  
            goto       standart    ;

            movlw      1  
             movwf      EEADR
            bsf        STATUS,5
            bsf        EECon1,0
            bcf        STATUS,5
            movf       EEDATA,w
            movwf      Contr_L1
            bcf        STATUS,2    ;   z    -  
                                   ;     1 EEPROM  ?
            xorlw      B'11111111' ;  FFh,  z=1    
            btfsc      STATUS,2    ;  EEPROM  
            goto       standart    ;

            movlw      2  
             movwf      EEADR
            bsf        STATUS,5
            bsf        EECon1,0
            bcf        STATUS,5
            movf       EEDATA,w
            movwf      Contr_L10
            bcf        STATUS,2    ;   z    -  
                                   ;     2 EEPROM  ?
            xorlw      B'11111111' ;  FFh,  z=1    
            btfsc      STATUS,2    ;  EEPROM  
            goto       standart    ;

            movlw      3  
             movwf      EEADR
            bsf        STATUS,5
            bsf        EECon1,0
            bcf        STATUS,5
            movf       EEDATA,w
            movwf      Contr_H0.1
            bcf        STATUS,2    ;   z    -  
                                   ;     3 EEPROM  ?
            xorlw      B'11111111' ;  FFh,  z=1    
            btfsc      STATUS,2    ;  EEPROM  
            goto       standart    ;

            movlw      4 
             movwf      EEADR
            bsf        STATUS,5
            bsf        EECon1,0
            bcf        STATUS,5
            movf       EEDATA,w
            movwf      Contr_H1
            bcf        STATUS,2    ;   z    -  
                                   ;     4 EEPROM  ?
            xorlw      B'11111111' ;  FFh,  z=1    
            btfsc      STATUS,2    ;  EEPROM  
            goto       standart    ;

            movlw      5 
            movwf      EEADR
            bsf        STATUS,5
            bsf        EECon1,0
            bcf        STATUS,5
            movf       EEDATA,w
            movwf      Contr_H10
            return                 ;

;*********************     
;                                **************
standart
            clrf       Contr_L0.1  ;    
            movlw      .9          ;          
            movwf      Contr_L0.1  ;            37.9
                                   ;
            clrf       Contr_L1    ;
            movlw      .7         ;
            movwf      Contr_L1    ;
                                   ;
            clrf       Contr_L10   ;
            movlw      .3          ;
            movwf      Contr_L10   ;
;----------------------------------------------------------------------------
            clrf      Contr_H0.1   ;    
                                   ;
            clrf       Contr_H1    ;           38.0      
            movlw      .8          ;
            movwf       Contr_H1   ;
                                   ;
            clrf       Contr_H10   ;
            movlw      .3          ;
            movwf       Contr_H10  ;
            return                 ;
;********     *******
Okruglenia                         ;
            clrf       H'40'       ;  0.0
            movlw      B'00000001' ;
            movwf      H'41'       ;  0.1
            movwf      H'42'       ;  0.1
            movlw      B'00000010' ;	
            movwf      H'43'       ;  0.2 
            movwf      H'44'       ;  0.2
            movlw      B'00000011' ;
            movwf      H'45'       ;  0.3
            movlw      B'00000100' ;
            movwf      H'46'       ;  0.4
            movwf      H'47'       ;  0.4
            movlw      B'00000101' ;
            movwf      H'48'       ;  0.5
            movlw      B'00000110' ;
            movwf      H'49'       ;  0.6
            movwf      H'4A'       ;  0.6
            movlw      B'00000111' ;
            movwf      H'4B'       ;  0.7
            movwf      H'4C'       ;  0.7
            movlw      B'00001000' ;
            movwf      H'4D'       ;  0.8
            movlw      B'00001001' ;
            movwf      H'4E'       ;  0.9
            movwf      H'4F'       ;  0.9
            return  
;***********       DS18B20 ****************

DOUT_LOW                           ; ,    
            bcf        PORTA,4     ;  . ,   
            bsf        STATUS,5    ;    0   
            movlw      b'00010000' ;
            movwf        TRISA     ;
            bcf        STATUS,5    ;
            retlw      H'00'       ;
;-------------------------------------------------------------------------

DOUT_HIGH                          ; ,   
                                   ;   .    -
                                   ;   1       
            bsf        STATUS,5    ;
            movlw      b'00010000' ;
            movwf        TRISA     ;     
            bcf        STATUS,5    ;
            retlw      H'00'       ;
;------------------------------------------------------------------------
DLIT_WR15                          ;   
            movlw      .3          ;
            movwf      count       ;        15
            decfsz     count,f     ;
            goto       $-1         ;
            nop                    ;
            nop                    ;
            retlw      H'00'       ;
;-------------------------------------------------------------------------
DLIT_WR60                          ;    60
            movlw      .19         ;
            movwf      count       ;
            decfsz     count,f     ;
            goto       $-1         ;
            retlw      H'00'       ;
;---------------------------------------------------------------------------
DLIT_WR160                         ;    160
           movlw       .52         ;
           movwf      count        ;
           decfsz     count,f      ;
           goto       $-1          ;
           nop                     ;
           retlw      H'00'        ;
;-------------------------------------------------------------------------- 
DRECEIVE                           ;     DS18B20
           movlw      .8           ;  8 ,  
           movwf      Schet        ; COM_REG 
           clrf       COM_REG      ;
C_DRECEIVE                         ;   
           call       DOUT_LOW     ;    ( 
                                   ;   .   1)
           call       DOUT_HIGH    ;     
           call       DLIT_WR15    ;     15-20
           btfss      PORTA,4      ;     - 0,
           bcf        STATUS,C     ;   0    .STATUS,
           btfsc      PORTA,4      ;      
           bsf        STATUS,C     ;  0  . COM_REG
           rrf        COM_REG,f    ;
           call       DLIT_WR60    ;      
           decfsz     Schet        ;  8 
           goto       C_DRECEIVE   ;
           retlw      H'00'        ;      -
                                   ; 
;---------------------------------------------------------------------------
DSEND                              ;      
                                   ;  DS18B20
           clrf       COM_REG      ;
           movwf      COM_REG      ;   
                                   ; 
           movlw      .8           ;     
           movwf      Schet        ;  
C_DSEND                            ;   
           call       DOUT_LOW     ;    
           rrf        COM_REG,f    ;  ,  
                                   ;      
           btfss      STATUS,C     ;    
           goto       DS_1         ;  0,     DS_1  
	   call       DOUT_HIGH    ;  1,    
                                   ;  . 1
DS_1                               ;
           call       DLIT_WR60    ;  60,  DS18B20
           call       DOUT_HIGH    ;   , . -
           decfsz     Schet        ;    1,   
           goto       C_DSEND      ;    , 
           retlw      H'00'        ;  0
;---------------------------------------------------------------------- ;
Test_inic                    ;    
                             ;        

          call       DOUT_HIGH     ;   RA4     DS18B20
          btfss      PORTA,4       ;   
          goto       Test_2        ;      0  -
          nop                      ; ,  -  
          call       DOUT_LOW      ;      1 -
          call       DLIT_WR160    ;     -
          call       DLIT_WR160    ;    640 (min 480)
          call       DLIT_WR160    ;
          call       DLIT_WR160    ;  1-Wire 

          call       DOUT_HIGH     ;      . 
          call       DLIT_WR60     ;     (  75)
          call       DLIT_WR15     ;
 
          clrf       dopcontr      ;      
          movlw      D'252'        ; 
Test_1    btfss      PORTA,4       ;    0  , 
          incf       dopcontr      ;  1  count,  -  
          addlw      01h           ; dopcontr   ,  -
          btfss      STATUS,Z      ;  1   
          goto       Test_1        ;
          goto       Pause         ;

Test_2    call       DLIT_WR160    ;   ,    
          call       DLIT_WR160    ;     
          call       DLIT_WR160    ;    
          goto       Test_inic     ;   

Pause     call       DLIT_WR160    ;     
          call       DLIT_WR160    ;
          call       DLIT_WR160    ;

          movlw      04h           ;   ,   
          xorwf      dopcontr,w    ;  count    4
          btfsc      STATUS,Z      ; count=4 ?
          movlw      0FFh          ;   -   
                                   ;    (W=0FFh)
          return                   ;   
;************************************************************************
;
;======      DS18B20======
TERMO
          clrf       TEMP_LO       ;     
          clrf       TEMP_HI       ;    
          movlw      b'00000000'   ;   
          movwf      INTCON        ;
          call       Test_inic     ;     
          xorlw      0FFh          ;   
          btfss      STATUS,Z      ;  -   
          goto       TERMO         ;
          nop                      ;
          movlw      H'CC'         ;   SKIP ROM (    
                                   ;  DS18B20)
          call       DSEND         ;   
          movlw      H'44'         ;   .  -       
                                   ;  
          call       DSEND         ;    
          call       DLIT_WR160    ;    750  12-. -
          call       DLIT_WR160    ; ,   
          call       DLIT_WR160    ;
          call       DLIT_WR160    ;
          call       DLIT_WR160    ;
          call       Test_inic     ;       
          xorlw      0FFh          ;    - 
          btfss      STATUS,Z      ; 
          goto       TERMO         ;  -   
          nop                      ;
          movlw      H'CC'         ;    " ROM"  
          call       DSEND         ;
          movlw      H'BE'         ;   " "
          call       DSEND         ;    1- 
          call       DRECEIVE      ;  .         
          movf       COM_REG,w     ;  1-    . w
          movwf      TEMP_LO       ;  .    
          call       DRECEIVE      ;  2-   
          movf       COM_REG,w     ;
          movwf      TEMP_HI       ;
          call       DOUT_LOW      ;     -
          call       DLIT_WR160    ;    800 (min 480),
          call       DLIT_WR160    ;     
          call       DLIT_WR160    ;
          call       DLIT_WR160    ;
          call       DLIT_WR160    ;
          call       DOUT_HIGH     ;
     
;------- .   fig_0.1, fig_1, fig_10------
          clrf       H'30'         ;    , -
          clrf       H'31'         ;     
          movf       TEMP_LO,w     ;
          andlw      B'00001111'   ;    
          movwf      H'30'         ;    ,  
          movlw      H'40'         ;     0.1 
          addwf      H'30',w       ;   
          movwf      FSR           ;
          movf       INDF,w        ;
          clrf       fig_0.1       ;     -
          clrf       fig_1         ;      
          clrf       fig_10        ; 
          movwf      fig_0.1       ;      
                                   ;  fig_0.1
;-------------------------------------------------------------------------- 
          movlw      .10           ;
          movwf      H'32'         ;
          movf       TEMP_LO,w     ;   , 
          andlw      B'11110000'   ;    ,
          movwf      H'31'         ;   
          movf       TEMP_HI,w     ;
          andlw      B'00000111'   ;
          iorwf      H'31'         ;       -
          swapf      H'31',w       ;    

;---------    -------------------
          bcf        STATUS,C      ;
          movwf      fig_1         ;
;            
povtor                             ; 
          movlw     H'0A'          ;   10   
          subwf     fig_1,w        ;   f-w  
                                   ;  ,  fig_1  -
          btfss      STATUS,C      ;  ,     10
          goto       over          ;
          movwf      fig_1         ; 
          incf       fig_10        ;     fig_10
          bcf        STATUS,C      ;       
          goto       povtor        ;
over      nop
PROVERKA  ;===    ======
;
VERX      clrf       H'37'         ;   
          clrf       H'3A'         ;
          bcf        STATUS,C      ;
          movf       fig_0.1,w     ;
          subwf      Contr_H0.1,w  ;
          btfsc      STATUS,C      ;
          goto       V_1           ;
          decf       Contr_H1,w    ;    ,
          movwf      H'37'         ;   Contr_H0.1,   
          bcf        STATUS,C      ;  fig_0.1,    
          movf       fig_1,w       ;     
          subwf      H'37'         ; Contr_H1  1, 
          btfsc      STATUS,C      ;     H'37' 
          goto       V_3           ;
V_2                                ;
          decf       Contr_H10,w   ;
          movwf      H'37'         ;
          bcf        STATUS,C      ;   
          movf       fig_10,w      ;
          subwf      H'37'         ;
          btfsc      STATUS,C      ;
          goto       NIG           ;
          bcf        PORTA,3       ;  ,  
          goto       Servis        ;    
V_1                                ;
          movf       fig_1,w       ;
          bcf        STATUS,C      ;
          subwf      Contr_H1,w    ; 
          btfss      STATUS,C      ;
          goto       V_2           ;
V_3                                ;
          bcf        STATUS,C      ;
          movf       fig_10,w      ;
          subwf      Contr_H10,w   ;        
          btfsc      STATUS,C      ;     
          goto       NIG           ;  ,    
          nop                      ;  ,  - 
          bcf        PORTA,3       ;       
          goto       Servis        ; 
;------------------------------------------------------

NIG                                ;   
          bcf        STATUS,C      ; 
          movf       fig_0.1,w     ;
          subwf      Contr_L0.1,w  ;   
          btfsc      STATUS,C      ;
          goto       N_4           ;
          decf       Contr_L1,w    ;
          movwf      H'3A'         ;  
          bcf        STATUS,C      ;
          movf       fig_1,w       ;
          subwf      H'3A'         ;  
          btfsc      STATUS,C      ;
          goto       N_5           ;
       
N_6       decf       Contr_L10,w   ;
          movwf      H'3A'         ;  
          movf       fig_10,w      ;
          bcf        STATUS,C      ;
          subwf      H'3A'         ;  
          btfss      STATUS,C      ;
          goto       N_7           ;
          bsf        PORTA,3       ;  
          goto       Servis 

N_4       bcf        STATUS,C      ;
          movf       fig_1,w       ;
          subwf      Contr_L1,w    ;
          btfss      STATUS,C      ;
          goto       N_6           ;
N_5                                ;
          movf       fig_10,w      ;
          subwf      Contr_L10,w   ; 
          btfsc      STATUS,C      ;  ,   -
          bsf        PORTA,3       ;    
N_7       nop                      ;  
;==================================== ==========
;************************************************************************

Servis                             ; . .   1
          movlw      B'10100000'   ;    -
          movwf      INTCON        ;  
          clrf       H'01'         ;  
          clrf       H'3C'         ;            
          clrf       H'3D'         ;                 
          clrf       H'3E' 
;-------------------------------------------------------------
          movlw      .4
          movf       H'3E' 
timer
          bcf        STATUS,Z      ;
          incf       H'3C'         ;
          btfss      STATUS,Z      ;
          goto       timer         ;
          bcf        STATUS,Z      ;                  
          incf       H'3D'         ;
          btfss      STATUS,Z      ;
          goto       timer         ;
          btfss      PORTB,5
          goto       Nastroyka
          decfsz     H'3E'
          goto       timer         ;
          bcf        STATUS,Z      ;         
          btfsc      PORTB,5       ;  ?
          goto       TERMO         ;
;=============================================================================
;=============================================================================
Nastroyka 
          movlw      .2            ;    .    2
          movwf      contr         ;
          movlw      B'10100000'   ;  
          movwf      INTCON        ;
          clrf       H'01'         ;   TMRO
          movlw      Contr_L0.1    ;      
          movwf      AdrFig        ;   
          movlw      B'00000100'   ;  .     
          movwf      Anod          ;       
          bcf        PORTA,3       ;  . RA3,     
                                   ;  ,     
                                   ;               
          movlw      .1            ;  1  0   _adres_  
          movwf      _adres_       ;   
          movlw      .2            ;     
          movwf      Interval      ;     2 
ert       call       zvon          ;   
         btfss      PORTB,5        ;
          goto       ert
;============       ==========
_1_       movlw      B'00000100'   ;
          movwf      Mercan        ;       
                                   ;                    
          btfss      PORTB,7       ;  
          goto       _3_           ; 
          btfss      PORTB,6       ;
          goto       _2_           ;
          btfss      PORTB,5       ;
          goto       Verx          ;
          goto       _1_           ;
;-----------------------------------------------------------------  
_2_       call       zvon 
          btfss      PORTB,6
          goto       _2_
          movf       Contr_L0.1,w  ;
          movwf      zapcontr      ;
          call       plus1         ;
          movwf       Contr_L0.1   ;
          goto       _1_           ;
;**********************************************************************
plus1                              ;    1 
          movlw      .1            ;    
          addwf      zapcontr      ;   Contr_...  
          movf       zapcontr,w    ;  -     
          sublw      b'00001010'   ; .   .10 (b'00001010'),
          bz         m_1           ;   ... (L-W) 
          goto       m_2           ; 
m_1       clrf       zapcontr      ; 
m_2       movf       zapcontr,w    ;
          return                   ;  
;*********************************************************************** 
_3_       call       zvon          ;    
          btfss      PORTB,7       ;     
          goto       _3_           ; 
          movlw      B'00000010'   ; 
          movwf      Mercan         ;
_4_       btfss      PORTB,6       ;    -   _5_
          goto       _5_           ;
          btfss      PORTB,7       ;
          goto       _6_           ; 
          btfss      PORTB,5       ;
          goto       Verx          ; 
          goto       _4_           ; 
;-------------------------------------------------------------------                     
_5_        call       zvon 
          btfss      PORTB,6
          goto       _5_           ;    1 
          movf       Contr_L1,w    ;     
          movwf      zapcontr      ;     (   )
          call       plus1         ;
          movwf       Contr_L1     ;
          goto       _4_           ;  
;====================================================================            
_6_        call       zvon         ;   
          btfss      PORTB,7     ;     
          goto       _6_           ; 
          movlw      B'00000001'   ;      
          movwf      Mercan        ;    
_7_       btfss      PORTB,6       ;
          goto       _8_           ;
          btfss      PORTB,5       ;
          goto       Verx          ;
          btfss      PORTB,7       ;
          goto       m_3           ;
          goto       _7_           ;
                      
m_3       call       zvon       ;      PORTB,7
          btfss      PORTB,7       ;     
          goto       m_3
          goto       _1_           ;
;-------------------------------------------------------------------                                              
_8_          call       zvon       ;     
          btfss      PORTB,6       ;  ,    Contr_L10
          goto       _8_      
          movf       Contr_L10,w   ; 
          movwf      zapcontr      ; 
          call       plus1         ;
          movwf       Contr_L10    ;
          goto       _7_           ;  

;*****************************************************************************                                                       
Verx      call       zvon          ;   <> 
          btfss      PORTB,5       ;
          goto       Verx          ;
          decf       contr         ;    .    1
          clrf       H'01'         ;   TMRO
          movlw      Contr_H0.1  ;      
          movwf      AdrFig        ;  
          movlw      B'00000100'  ;  .     
          movwf      Anod          ;       
          bcf        PORTA,3     ;  . RA3,     
          movlw      B'00000100' ;      
          movwf      Mercan        ;                                                      
;------------------------------------------------------------------------
Indic_H                            ;
a1a       btfss      PORTB,7       ;  
          goto       b3b           ; 
          btfss      PORTB,6       ;
          goto       a2a           ;
          btfss      PORTB,5       ;
          goto       aab           ; 
          goto       a1a           ;
aab       call       zvon          ;
          btfss      PORTB,5       ;
          goto       aab           ;
          clrf       contr         ;
          call       zapis         ;
          goto       TERMO         ;
;-----------------------------------------------------------------          
a2a       call       zvon          ;   <>
          btfss      PORTB,6       ;
          goto       a2a           ;                         
          movf       Contr_H0.1,w  ;
          movwf      zapcontr      ;
          call       plus1         ;
          movwf      Contr_H0.1    ;
          goto       a1a           ;
;==================================================================
b3b                                ;   <>             
          call       zvon          ;
          btfss      PORTB,7       ;
          goto       b3b           ;                              
          movlw      B'00000010'   ;    
          movwf      Mercan        ;     
b4b       btfss      PORTB,6       ;    -   b5b
          goto       b5b           ;
          btfss      PORTB,7       ;
          goto       b6b           ; 
bbm       btfss      PORTB,5       ;
          goto       bjj           ; 
          goto       b4b           ;
bjj       btfss      PORTB,5       ;
          goto       $-1           ;
          call       zvon          ;
          btfss      PORTB,5       ;
          goto       bjj           ;
          clrf       contr         ;      
          call       zapis         ; 
          goto       TERMO         ;    
;-------------------------------------------------------------------
b5b                                ;   <>             
          call       zvon          ;
          btfss      PORTB,6       ;
          goto       b5b           ;                     
                                   ;    1 
          movf       Contr_H1,w    ;     
          movwf      zapcontr      ;     (   )
          call       plus1         ;
          movwf       Contr_H1     ;
          goto       b4b           ;
;===================================================================
b6b       call       zvon          ;   <>  
          btfss      PORTB,7       ;
          goto       b6b           ;                                         
          movlw      B'00000001'   ;      
          movwf      Mercan         ;    
b7c       btfss      PORTB,6       ;
          goto       b8m           ;
          btfss      PORTB,7       ;
          goto       mq3           ;
          goto       b9m           ;    
mq3       call       zvon          ;   <>                
          btfss      PORTB,7       ;      PORTB,7
          goto       mq3           ;                     
          movlw      B'00000100'   ;      
          movwf      Mercan        ;     
          movlw      Contr_H0.1    ;      
          movwf      AdrFig        ;   
          movlw      B'00000100'   ;  .     
          movwf      Anod          ;      
          goto       a1a           ; 
b9m       btfss      PORTB,5       ;
          goto       bas           ; 
          goto       b7c           ;
bas       call       zvon          ;
          btfss      PORTB,5       ;
          goto       bas           ;
          decf       contr         ;
          call       zapis         ;
          bz         TERMO         ;   0,   
                                   ; 
;-------------------------------------------------------------------- 
b8m       call       zvon          ;   <> 
          btfss      PORTB,6       ;
          goto       b8m           ;                                            
          movf       Contr_H10,w   ;     
          movwf      zapcontr      ; ,    Contr_L10
          call       plus1         ;
          movwf       Contr_H10    ;
          goto       b7c           ;
;-------------------   < > ------------------
zvon      clrf       H'26'         ;
          clrf       H'27'         ;      
          movlw      .40           ;            
          movwf      H'27'
z_1       bcf        STATUS,2
          incf       H'26'
          btfss      STATUS,2
          goto       z_1
          bcf        STATUS,2
          decf       H'27'
          btfss      STATUS,2
          goto       z_1
          bcf        STATUS,2
          return
;*********************************************************************

zapis ;    Contr_L...- Contr_H...  
      ;      EEPROM    0,1,2,3,4,5.
  
         bcf         INTCON,7     ;   
         movlw       0            ;   .w   -
                                  ;    EEPROM
         movwf       EEADR        ;    .EEADR,-
                                  ;     EEPROM  
         movf        Contr_L0.1,w ;    w  .EEDATA, 
         movwf       EEDATA       ;  . 
                                  ;  EEPROM  
         bsf         STATUS,5     ;     -
         bsf         EECon1,2     ;  EEPROM   
                                  ;  "1"    EECON1
         movlw       055h         ;        
         movwf       EECon2       ;          
         movlw       0AAh         ;         
         movwf       EECon2       ;       ------------
         bsf         EECon1,1     ;       ------------
         btfsc       EECon1,1     ;
         goto        $-1
         bcf         EECon1,2     ;    ?
         bcf         STATUS,5     ; 
;-----------------------------------------
         movlw       1            ;
         movwf       EEADR        ;
         movf        Contr_L1,w   ;
         movwf       EEDATA       ;
         bsf         STATUS,5     ;
         bsf         EECon1,2     ;

         movlw       055h         ;
         movwf       EECon2       ;
         movlw       0AAh         ;
         movwf       EECon2       ;
         bsf         EECon1,1     ;
         btfsc       EECon1,1     ;
         goto        $-1
         bcf         EECon1,2   ;
         bcf         STATUS,5     ; 
;-------------------------------------------
         movlw       2            ;
         movwf       EEADR        ;
         movf        Contr_L10,w   ;
         movwf       EEDATA       ;
         bsf         STATUS,5     ;
         bsf         EECON1,2     ;

         movlw       055h         ;
         movwf       EECon2       ;
         movlw       0AAh         ;
         movwf       EECon2       ;
         bsf         EECon1,1     ;
         btfsc       EECon1,1     ;
         goto        $-1
         bcf         EECon1,2     ;
         bcf         STATUS,5     ; 
;-------------------------------------------
         movlw       3            ;
         movwf       EEADR        ;
         movf        Contr_H0.1,w   ;
         movwf       EEDATA       ;
         bsf         STATUS,5     ;
         bsf         EECON1,2     ;

         movlw       055h         ;
         movwf       EECon2       ;
         movlw       0AAh         ;
         movwf       EECon2       ;
         bsf         EECon1,1     ;
         btfsc       EECon1,1     ;
         goto        $-1
         bcf         EECon1,2     ;
         bcf         STATUS,5     ; 
;---------------------------------------------
          movlw       4            ;
         movwf       EEADR        ;
         movf        Contr_H1,w   ;
         movwf       EEDATA       ;
         bsf         STATUS,5     ;
         bsf         EECon1,2     ;

         movlw       055h         ;
         movwf       EECon2       ;
         movlw       0AAh         ;
         movwf       EECon2       ;
         bsf         EECon1,1     ;
         btfsc       EECon1,1     ;
         goto        $-1
         bcf         EECon1,2    ;
         bcf         STATUS,5     ; 
;---------------------------------------  
          movlw       5           ;
         movwf       EEADR        ;
         movf        Contr_H10,w   ;
         movwf       EEDATA       ;
         bsf         STATUS,5     ;
         bsf         EECON1,2     ;

         movlw       055h         ;
         movwf       EECon2       ;
         movlw       0AAh         ;
         movwf       EECon2       ;
         bsf         EECon1,1     ;
         btfsc       EECon1,1     ;
         goto        $-1
         bcf         EECon1,2     ;
         bcf         STATUS,5     ; 
;-------------------------------------
        bsf         INTCON,7     ;
        goto         TERMO
;=======================================
;========================================
        end         

         


       


         

                                      
