 
;            
; ======================================================================================
; ======================================================================================

	list	p=pic16f84a					;  
	include	<p16f84a.inc>					; 
	__CONFIG _HS_OSC & _WDT_OFF & _PWRTE_ON & _CP_OFF	;  

        cblock  h'0c'		;    0,    h'0c				
mode                            ;   :		
                                ;0=, 1=, 2=		
count1                          ; 			
count2                          ; ( 1msec)
count3                          ;    1
count4                          ;
count5                          ;
count6
count7
count8
otchet	
sklad                           ;     
       endc			;   				


;****************     ***********************
        org     0               ; (     0)		
        goto    init
        org     4               ;   
                                ;
init    clrf    INTCON          ;   INTCON
        bsf     STATUS,5        ;  1
        clrf    TRISA           ;      
        movlw   b'01111010'     ; RB 0,2,7     
        movwf   TRISB    	;  
        movlw   b'10000000'     ;   
        movwf   OPTION_REG      ;  OPTION_REG
        bcf     STATUS,5        ;  0
        clrf    mode            ;  mode, count1, count2
        clrf    count1          ;
        clrf    count2          ;
        bsf     PORTB,0         ;   
        call    vent
        bcf     PORTB,0
        movlw   b'00000101'     ;     -
        movwf   sklad           ;  sklad
        goto    revers


;********************     *********************
drive
       
        bsf     PORTB,7         ; RB7 = 1   
        btfsc   PORTB,5         ;RB5 = 0 ?                
        goto    $-1             ;.             
        movlw   d'5'            ;  (5)
        movwf   count1          ;  
loop    call    timer           ; 1
        decfsz  count1,f        ;count - 1 = 0 ?
        goto    loop            ;. 
        bcf     PORTB,7         ; RB7 = 0     
        btfss   PORTB,5         ;RB5 = 1 ?
        goto    $-1             ;. 
        nop
        movf    sklad,w         ;
        movwf   PORTA           ;
         movlw   d'250'            ;  (5)
        movwf   count1          ;  
look    call    timer           ; 1
        decfsz  count1,f        ;count - 1 = 0 ?
        goto    look            ;. 
        movf    PORTA,w         ;  PORTA
        sublw   b'00000101'    ;  
        bnz     drive2          ;  ,   
                                ;     0
        movf    mode,w          ;  mode
        sublw   d'1'            ; ?
        bz      drive1          ;  ,      0
        movlw   b'00001001'     ;.  
        goto    drive_end       ;   PORTA
drive1
        movlw   b'00000110'     ; 
        goto    drive_end       ;   PORTA
;------------------------------
drive2
        movf    PORTA,w         ;  PORTA
        sublw   b'00000110'    ;  
        bnz     drive4          ;
        movf    mode,w          ;  mode
        sublw   d'1'            ; ?
        bz      drive3          ;. 
        movlw   b'00000101'     ;.  
        goto    drive_end       ;   PORTA
drive3
        movlw   b'00001010'     ; 
        goto    drive_end       ;   PORTA
;-------
drive4
        movf    PORTA,w         ;  PORTA
        sublw   b'00001010'    ;  
        bnz     drive6          ;
        movf    mode,w          ;  mode
        sublw   d'1'            ; ?
        bz      drive5          ;. 
        movlw   b'00000110'     ;.  
        goto    drive_end       ;   PORTA
drive5
        movlw   b'00001001'     ; 
        goto    drive_end       ;   PORTA
;-------
drive6
        movf    PORTA,w         ;  PORTA
        sublw   b'00001001'    ;  
        bnz     drive8          ;Unmatch
        movf    mode,w          ;Read mode
        sublw   d'1'            ; ?
        bz      drive7          ;. 
        movlw   b'00001010'     ;.  
        goto    drive_end       ;   PORTA
drive7
        movlw   b'00000101'     ; 
        goto    drive_end       ;   PORTA
;-------
drive8
        movlw   b'00000101'     ; 

drive_end
        clrf    PORTA           ;     -
        movwf   sklad           ;       
        goto    revers          ;   
                                ;  

;*************    1  *****************
timer
        movlw   d'200'          ;  
        movwf   count2          ;  
tmlp    nop                     ; 
        nop                     ; 
        decfsz  count2,f        ;count - 1 = 0 ?
        goto    tmlp            ;. 
        return                  ;.   -  
                                ;  
;********************************************************
;-----------     ----------------
revers
        btfss   PORTB,3         ; 
        goto    ostan_2         ;
        btfss   PORTB,4         ;
        goto    ostan_1         ;
        movf    mode,w          ;
        bnz     chop            ;
shop_1  movlw   d'1'            ;
        movwf   mode            ;
        goto    drive           ;
;-------------------------------------------------
chop    goto    drive           ;
;-------------------------------------------------
ostan_1                         ;
        movf    mode,w          ;
        bz      shop_2          ;
        sublw   d'2'            ;
        bnz     skok            ;
        goto    drive           ;
;------------------------------------------------
skok    clrf    mode            ;
        call    timer_1chas     ;
        movlw   d'2'            ;
        movwf   mode            ;
        movlw   b'00000101'     ;
        movwf   sklad           ;
        goto    drive           ;
;-------------------------------------------------
shop_2  movlw   d'2'            ;
        movwf   mode            ;
        goto    drive           ;
;-------------------------------------------------
ostan_2                         ;
                                ;
        movf   mode,w           ;
        bz     shop_1           ;
        sublw  d'1'             ;
        bnz    chpok            ;
        goto   drive            ;
;------------------------------------------------
chpok   clrf    mode            ; 
        call    timer_1chas     ;
        movlw   d'1'            ;
        movwf   mode            ;
        movlw   b'00000101'     ;
        movwf   sklad           ;
        goto    drive           ;
;===============================================

vent                            ;   -
        movlw   d'40'            ;   10 
        movwf   count8          ;
ztv2    movlw   d'250'           ;
        movwf   count7          ; 
ctv1    movlw   d'200'           ;
        movwf   count6          ;

cont    nop
        nop
        decfsz  count6,f        ;
        goto    cont            ;
        decfsz  count7,f        ;
        goto    ctv1            ;
        decfsz  count8,f        ;
        goto    ztv2            ;
        return
;================================================
timer_1min
        movlw   d'240'           ;
        movwf   count5          ;
tim33   movlw   d'250'           ;
        movwf   count4          ;
tim22   movlw   d'200'           ;
        movwf   count3          ;

tim11   nop
        nop
        decfsz  count3,f        ;
        goto    tim11           ;
        decfsz  count4,f        ;
        goto    tim22           ;
        decfsz  count5,f        ;
        goto    tim33           ;
        return
;************ 1 ********************
timer_1chas                     ;
        clrf    count2          ;
        movlw   d'15'           ;
        movwf   count2          ;
yyy     movlw   d'3'            ;
        movwf   otchet          ;
zzz     call    timer_1min      ;
        decfsz  otchet          ;
        goto    zzz             ;
        bsf     PORTB,0         ;
        call    timer_1min      ;
        bcf     PORTB,0         ;
        decfsz  count2,f        ;
        goto    yyy             ;
        return
;***************************************************
        end    
